import math
from matrix import matx, matutils, Comp
from data import data, datautils, Compd
from exec import Terminate

class Compa:
    def _tfloatp(a) -> float:
        try:   
            a = Comp._tfloat(a)
            if a is None: raise Exception
            if a <= 0: raise Exception(str(a)+" is not positive")
            return a
        except Exception as e:
            print(e)
    def _tdict(a) -> bool:
        try:
            if type(a) is dict: return True
            else: raise Exception(str(type(a))+" is not dict")
        except Exception as e:
            print(e)
    def _matchkeys(a: dict, b: dict) -> bool:
        try:
            if Compa._tdict(a) is None or Compa._tdict(b) is None: raise Exception
            a = a.keys()
            b = list(b.keys())
            if len(a) != len(b): raise Exception(str(len(a))+" != "+str(len(b)))
            for i in a:
                if i in b:
                    b.remove(i)
                else: raise Exception("Keys are not same")
            return True
        except Exception as e:
            print(e)

class _Calculate:
    # regression
    # returns parameter using gradient descent for linear regression
    @staticmethod
    def _linregp(d: tuple, p: matx, a: float, ret=False) -> matx:
        try:
            if d[0][0].rowlen != p.rowlen: raise Exception(str(d[0][0].rowlen)+" != "+str(p.rowlen))
            newp = list()
            p = matutils.tpose(p, True)
            for i in range(p.collen):
                par = p.mele(i, 0, False, True)
                for j in range(len(d[1])): par -= a*d[0][j].mele(0, i, False, True)*matutils.msub(matutils.mmult(d[0][j], p, True), d[1][j], True).mele(0, 0, False, True)
                newp.append(par)
            return matx(tuple(newp), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns parameter using gradient descent for weighted linear regression
    @staticmethod
    def _wlinregp(d: tuple, p: matx, a: float, w: tuple, ret=False) -> matx:
        try:
            if d[0][0].rowlen != p.rowlen: raise Exception(str(d[0][0].rowlen)+" != "+str(p.rowlen))
            newp = list()
            p = matutils.tpose(p)
            for i in range(p.collen):
                par = p.mele(i, 0, False, True)
                for j in range(len(d[1])): par -= a*w[j]*d[0][j].mele(0, i, False, True)*matutils.msub(matutils.mmult(d[0][j], p, True), d[1][j], True).mele(0, 0, False, True)
                newp.append(par)
            return matx(tuple(newp), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def _lsqweights(d: tuple, xm: matx, t: float, ret=False) -> tuple:
        try:
            if d[0][0].rowlen != xm.rowlen: raise Exception(str(d[0][0].rowlen)+" != "+str(xm.rowlen))
            w = list()
            for i in d[0]:
                w1 = matutils.msub(i, xm, True)
                w1 = matutils.mmult(w1, matutils.tpose(w1, True), True).mele(0, 0, False, True)
                w.append(math.e**(-w1/t**2))
            return tuple(w)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns coefficient of determination for regression
    @classmethod
    def _coofdet(self, d: tuple, p: matx, ret=False) -> float:
        try:
            y = self._ypredy(d, p, True)
            ym = sum([i.mele(0, 0, False, True) for i in d[1]])/len(d[1])
            ssr = sum([(i[1] - ym)**2 for i in y]) 
            sst = sum([(i[0] - ym)**2 for i in y])
            return ssr/sst
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns actual and predicted y
    @staticmethod
    def _ypredy(d: tuple, p: matx, ret=False) -> list:
        try:
            return [[d[1][i].mele(0, 0, False, True), _Predict._linreg(p, d[0][i], True)] for i in range(len(d[1]))]
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # classification
    # returns parameter using gradient descent for logistic regression
    @staticmethod
    def _logregp(d: tuple, p: matx, a: float, ret=False) -> matx:
        try:
            if d[0][0].rowlen != p.rowlen: raise Exception(str(d[0][0].rowlen)+" != "+str(p.rowlen))
            newp = list()
            p = matutils.tpose(p, True)
            for i in range(p.collen):
                par = p.mele(i, 0, False, True)
                for j in range(len(d[1])): par -= a*d[0][j].mele(0, i, False, True)*((1/(1+pow(math.e, -matutils.mmult(d[0][j], p, True).mele(0, 0, False, True))))-d[1][j].mele(0, 0, False, True))
                newp.append(par)
            return matx(tuple(newp), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # retuns misclassifications after logistic regression
    @staticmethod
    def _misclasslogreg(d: tuple, p: matx, ret=False) -> dict:
        try:
            dic = dict()
            dic.setdefault("0", [0, 0, []])
            dic.setdefault("1", [0, 0, []])
            for i in range(len(d[1])):
                if d[1][i].mele(0, 0, False, True) == 0:
                    dic["0"][0] += 1
                    if _Predict._logreg(p, d[0][i], True) == True: 
                        dic["0"][1] += 1
                        dic["0"][2].append(d[0][i].matxl()[0])
                else:
                    dic["1"][0] += 1
                    if _Predict._logreg(p, d[0][i], True) == False: 
                        dic["1"][1] += 1
                        dic["1"][2].append(d[0][i].matxl()[0])
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns mean x and phi for GDA
    @staticmethod
    def _meanx_phi(d: tuple, ret=False) -> dict:
        try:
            y1 = 0
            y2 = 0
            lx = d[0][0].rowlen
            x1 = matutils.zerom(1, lx, True)
            x2 = matutils.zerom(1, lx, True)
            for i in range(len(d[1])):
                if d[1][i].mele(0, 0) == 0: 
                    y1 += 1
                    x1.matx = matutils.madd(x1, d[0][i], True)
                else: 
                    x2.matx = matutils.madd(x2, d[0][i], True)
                    y2 += 1
            return {"mean": [matutils.smult(1/y1, x1, True).matx[0], matutils.smult(1/y2, x2, True).matxl()[0]], "phi": [y1/(y1+y2), y2/(y1+y2)]}
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns covariance and n for GDA
    @staticmethod
    def _cov_n(d: tuple, x1: matx, x2: matx, ret=False) -> dict:
        try:
            xl = d[0][0].rowlen
            cov = matutils.zerom(xl, xl, True)
            for i in range(len(d[1])):
                if d[1][i].mele(0, 0, False, True) == 0:
                    xd = matutils.msub(d[0][i], x1, True)
                    cov.matx = matutils.madd(cov, matutils.mmult(matutils.tpose(xd, True), xd, True), True)
                else:
                    xd = matutils.msub(d[0][i], x2, True)
                    cov.matx = matutils.madd(cov, matutils.mmult(matutils.tpose(xd, True), xd, True), True)
            return {"cov": matutils.smult(1/len(d[1]), cov, True).matxl(), "n": xl}
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns misclassifications after gda
    @staticmethod
    def _misclassgda(d: tuple, d1: dict, ret=False) -> dict:
        try:
            dic = dict()
            dic.setdefault("0", [0, 0, []])
            dic.setdefault("1", [0, 0, []])
            for i in range(len(d[1])):
                if d[1][i].mele(0, 0, False, True) == 0:
                    dic["0"][0] += 1
                    if _Predict._gda(d1, d[0][i]) == True: 
                        dic["0"][1] += 1
                        dic["0"][2].append(d[0][i].matxl()[0])
                else:
                    dic["1"][0] += 1
                    if _Predict._gda(d1, d[0][i]) == False: 
                        dic["1"][1] += 1
                        dic["1"][2].append(d[0][i].matxl()[0])
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # scale x values between [0, 1]
    @staticmethod
    def _scale0to1x(x: matx, ret=False) -> dict:
        try:
            x = matutils.tpose(x, True)
            mx = list()
            mn = list()
            for i in x.matx: mn.append(min(i))
            x = matutils.msub(x, matx(tuple([tuple([mn[i] for j in range(x.rowlen)]) for i in range(x.collen)]), False, True), True)
            for i in x.matx: mx.append(max(i))
            x = tuple([matutils.smult(1/mx[i[0]], i[1], True) for i in enumerate(matutils.matlxtox(x, True))])
            x = matutils.matlxtox(matutils.tpose(matutils.matxtolx(x, True), True), True)
            if x is None: raise Exception
            return {"constant": matx(tuple(mn), False, True), "factor": matx(tuple(mx), False, True), "values": x}
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # scale x and y values between [0,1] for linear regression
    @classmethod
    def _scale0to1(self, d: data, ret=False) -> dict:
        try:
            x = self._scale0to1x(d.getax(), True)
            y = self._scale0to1x(d.getay(), True)
            return {"constant": matx(tuple(x["constant"].matxl()[0] + y["constant"].matxl()[0]), False, True), "factor": matx(tuple(x["factor"].matxl()[0] + y["factor"].matxl()[0]), False, True), "data": data(x["values"], y["values"], False, True)}
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # scale original parameter values for linear regression
    @staticmethod
    def _scale0to1linreg(c: matx, f: matx, p: matx, ret=False) -> matx:
        try:
            pn = list()
            p = matx(tuple([(1/f.mele(0, -1, False, True))*i for i in p.matx[0]]), False, True)
            c = matx(tuple([c.mele(0, i, False, True)/f.mele(0, i, False, True) for i in range(c.rowlen)]), False, True)
            for i in range(p.rowlen):
                if i == 0: pn.append(p.mele(0, i, False, True)+sum(c.matx[0][:-1])-c.mele(0, -1, False, True))
                else: pn.append(p.mele(0, i, False, True)*f.mele(0, i-1, False, True))
            return matx(tuple(pn), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # scale to original parameter values for linear regression
    @staticmethod
    def _scaleorignlinreg(c: matx, f: matx, p: matx, ret=False) -> matx:
        try:
            pn = list()
            c = matx(tuple([c.mele(0, i, False, True)/f.mele(0, i, False, True) for i in range(c.rowlen)]), False, True)
            for i in range(p.rowlen):
                if i == 0: pn.append(p.mele(0, i,False, True)-sum(c.matx[0][:-1])+c.mele(0, -1, False, True))
                else: pn.append(p.mele(0, i, False, True)*(1/f.mele(0, i-1, False, True)))
            return matx(tuple([f.mele(0, -1, False, True)*i for i in pn]), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # scale original parameter values for logistic regression
    @staticmethod
    def _scale0to1logreg(c: matx, f: matx, p: matx, ret=False) -> matx:
        try:
            pn = list()
            c = matx(tuple([c.mele(0, i, False, True)/f.mele(0, i, False, True) for i in range(c.rowlen)]), False, True)
            for i in range(p.rowlen):
                if i == 0: pn.append(p.mele(0, i, False, True)+sum(c.matx[0]))
                else: pn.append(p.mele(0, i, False, True)*f.mele(0, i-1, False, True))
            return matx(tuple(pn), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # scale to original values for logistic regression
    @staticmethod
    def _scaleorignlogreg(c: matx, f: matx, p: matx, ret=False) -> matx:
        try:
            pn = list()
            c = matx(tuple([c.mele(0, i, False, True)/f.mele(0, i, False, True) for i in range(c.rowlen)]), False, True)
            for i in range(p.rowlen):
                if i == 0: pn.append(p.mele(0, i, False, True)-sum(c.matx[0]))
                else: pn.append(p.mele(0, i, False, True)*(1/f.mele(0, i-1, False, True)))
            return matx(tuple(pn), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
class _Regression:
    # performs linear regression using gradient descent
    @staticmethod
    def _gdlinreg(d: data, p: matx, a: float, m: int, pr: float, ret=False) -> dict:
        try:
            c = 0
            err = float("inf")
            while c < m:
                pn = _Calculate._linregp(d.data1(), p, a, True)
                if pn is None: raise Exception
                err = math.sqrt(sum([((i[1]-p.mele(0, i[0], False, True))/i[1])**2 for i in enumerate(pn.matx[0])])/p.rowlen)
                if err < pr: break
                p.matx = pn
                for i in range(pn.rowlen):
                    if pn.mele(0, i, False, True) == float("nan") or pn.mele(0, i, False, True) == float("inf") or pn.mele(0, i, False, True) == float("-inf"):
                        print("parameter", i, "is ", pn.mele(0, i, False, True))
                        return {"parameters": p.matxl()[0]}
                c += 1
            dic = dict()
            dic["parameters"] = p.matxl()[0]
            dic["iterations"] = c
            dic["r^2"] = _Calculate._coofdet(d.data, p, True)
            if dic["r^2"] is None: raise Exception
            try: dic["r^2_adj"] = 1-((1-dic["r^2"])*(d.datalen-1)/(d.datalen-d.xvars-1))
            except ZeroDivisionError: dic["r^2_adj"] = float('nan')
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # performs weighted linear regression using gradient descent
    @staticmethod
    def _gdwlinreg(d: data, p: matx, a: float, x: matx, t: float, m: int, pr: float, ret=True) -> dict:
        try:
            w = _Calculate._lsqweights(d.data, x, t, True)
            if w is None: raise Exception
            d1 = d.data1()
            c = 0
            err = float("inf")
            while c < m:
                pn = _Calculate._wlinregp(d1, p, a, w, True)
                if pn is None: raise Exception
                err = math.sqrt(sum([((i[1]-p.matx[0][i[0]])/i[1])**2 for i in enumerate(pn.matx[0])])/p.rowlen)
                if err < pr: break
                for i in range(pn.rowlen):
                    if pn.mele(0, i, False, True) == float("nan") or pn.mele(0, i, False, True) == float("inf") or pn.mele(0, i, False, True) == float("-inf"):
                        print("parameter", i, "is ", pn.mele(0, i, False, True))
                        return {"parameters": p.matxl()[0]}
                p.matx = pn
                c += 1
            del d1
            dic = dict()
            dic["parameters"] = p.matxl()[0]
            dic["iterations"] = c
            dic["r^2"] = _Calculate._coofdet(d.data, p, True)
            if dic["r^2"] is None: raise Exception
            try: dic["r^2_adj"] = 1-((1-dic["r^2"])*(d.datalen-1)/(d.datalen-d.xvars-1))
            except ZeroDivisionError: dic["r^2_adj"] = float('nan')
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # performs linear regression using matrix method
    @staticmethod
    def _matlinreg(d: data, ret=False) -> dict:
        try:
            d1 = datautils.data1(d)
            x = d1.getax()
            y = d1.getay()
            del d1
            xt = matutils.tpose(x, True)
            x.matx = matutils.mmult(xt, x, True)
            y.matx = matutils.mmult(xt, y, True)
            p = matutils.mmult(matutils.tpose(y, True), matutils.invse(x, True), True)
            dic = dict()
            dic["parameters"] = p.matxl()[0]
            dic["r^2"] = _Calculate._coofdet(d.data, p, True)
            if dic["r^2"] is None: raise Exception
            try: dic["r^2_adj"] = 1-((1-dic["r^2"])*(d.datalen-1)/(d.datalen-d.xvars-1))
            except ZeroDivisionError: dic["r^2_adj"] = float('nan')
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # performs weighted linear regression using matrix method
    @staticmethod
    def _matwlinreg(d: data, x: matx, t: float, ret=False) -> dict():
        try:
            w = _Calculate._lsqweights(d.data, x, t, True)
            if w is None: raise Exception
            d1 = datautils.data1(d)
            y = d1.getay()
            x = d1.getax()
            xt = matutils.tpose(matutils.smultfac(w, x, True, True))
            del d1
            x.matx = matutils.mmult(xt, x, True)
            y.matx = matutils.mmult(xt, y, True)
            p = matutils.mmult(matutils.tpose(y, True), matutils.invse(x, True), True)
            dic = dict()
            dic["parameters"] = p.matxl()[0]
            dic["r^2"] = _Calculate._coofdet(d.data, p, True)
            if dic["r^2"] is None: raise Exception
            try: dic["r^2_adj"] = 1-((1-dic["r^2"])*(d.datalen-1)/(d.datalen-d.xvars-1))
            except ZeroDivisionError: dic["r^2_adj"] = float('nan')
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # preforms linear regression after scaling x and y values between [0, 1] using gradient descent
    @staticmethod
    def _gdslinreg(d: data, p: matx, a: float, m: int, pr: float, ret=False) -> dict:
        try:
            sc = _Calculate._scale0to1(d, True)
            if sc is None: raise Exception
            d1 = sc["data"].data1()
            p = _Calculate._scale0to1linreg(sc["constant"], sc["factor"], p, True)
            if p is None: raise Exception
            c = 0
            err = float("inf")
            while c < m:
                pn = _Calculate._linregp(d1, p, a, True)
                if pn is None: raise Exception
                err = math.sqrt(sum([((i[1]-p.mele(0, i[0], False, True))/i[1])**2 for i in enumerate(pn.matx[0])])/p.rowlen)
                if err < pr: break
                for i in range(pn.rowlen):
                    if pn.mele(0, i, False, True) == float("nan") or pn.mele(0, i, False, True) == float("inf") or pn.mele(0, i, False, True) == float("-inf"):
                        print("parameter", i, "is ", pn.mele(0, i, False, True))
                        return {"parameters": p.matxl()[0]}
                p.matx = pn
                c += 1
            p = _Calculate._scaleorignlinreg(sc["constant"], sc["factor"], p, True)
            if p is None: raise Exception
            del sc
            dic = dict()
            dic["parameters"] = p.matxl()[0]
            dic["iterations"] = c
            dic["r^2"] = _Calculate._coofdet(d.data, p, True)
            if dic["r^2"] is None: raise Exception
            try: dic["r^2_adj"] = 1-((1-dic["r^2"])*(d.datalen-1)/(d.datalen-d.xvars-1))
            except ZeroDivisionError: dic["r^2_adj"] = float('nan')
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # performs weighted linear regression after scaling x and y values between [0, 1] using gradient descent
    @staticmethod
    def _gdswlinreg(d: data, p: matx, a: float, x: list, t: float, m: int, pr: float, ret=False) -> dict:
        try:
            sc = _Calculate._scale0to1(d, True)
            if sc is None: raise Exception
            w = _Calculate._lsqweights(d.data, x, t, True)
            if w is None: raise Exception
            d1 = sc["data"].data1()
            p = _Calculate._scale0to1linreg(sc["constant"], sc["factor"], p)
            c = 0
            err = float("inf")
            while c < m:
                pn = _Calculate._wlinregp(d1, p, a, w, True)
                if pn is None: raise Exception
                err = math.sqrt(sum([((i[1]-p.mele(0, i[0], False, True))/i[1])**2 for i in enumerate(pn.matx[0])])/p.rowlen)
                if err < pr: break
                p.matx = pn
                for i in range(pn.rowlen):
                    if pn.mele(0, i, False, True) == float("nan") or pn.mele(0, i, False, True) == float("inf") or pn.mele(0, i, False, True) == float("-inf"):
                        print("parameter", i, "is ", pn.mele(0, i, False, True))
                        return {"parameters": p.matxl()[0]}
                c += 1
            p = _Calculate._scaleorignlinreg(sc["constant"], sc["factor"], p, True)
            if p is None: raise Exception
            del sc
            dic = dict()
            dic["parameters"] = p.matxl()[0]
            dic["iterations"] = c
            dic["r^2"] = _Calculate._coofdet(d.data, p, True)
            if dic["r^2"] is None: raise Exception
            try: dic["r^2_adj"] = 1-((1-dic["r^2"])*(d.datalen-1)/(d.datalen-d.xvars-1))
            except ZeroDivisionError: dic["r^2_adj"] = float('nan')
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class _Classification:
    # performs logistic regression using gradient descent
    @staticmethod
    def _gdlogreg(d: data, p: matx, a: float, m: int, pr: float, ret=False) -> dict:
        try:
            d1 = d.data1()
            c = 0
            err = float("inf")
            while c < m:
                pn = _Calculate._logregp(d1, p, a, True)
                if pn is None: raise Exception
                err = math.sqrt(sum([((i[1]-p.mele(0, i[0], False, True))/i[1])**2 for i in enumerate(pn.matx[0])])/p.rowlen)
                if err < pr: break
                p.matx = pn
                for i in range(pn.rowlen):
                    if pn.mele(0, i, False, True) == float("nan") or pn.mele(0, i, False, True) == float("inf") or pn.mele(0, i, False, True) == float("-inf"):
                        print("parameter", i, "is ", pn.mele(0, i, False, True))
                        return {"parameters": p.matxl()[0]}
                c += 1
            miscl = _Calculate._misclasslogreg(d.data, p, True)
            if miscl is None: raise Exception
            return {"parameters": p.matxl()[0], "iterations": c, "misclassifications": miscl}
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # performs gaussian discriminant analysis
    @staticmethod
    def _gda(d: data, ret=False) -> dict:
        try:
            d = d.data
            dic1 = _Calculate._meanx_phi(d, True)
            if dic1 is None: raise Exception
            dic2 = _Calculate._cov_n(d, matx(dic1["mean"][0]), matx(dic1["mean"][1]), True)
            if dic2 is None: raise Exception
            dic1.update(dic2)
            miscl =_Calculate._misclassgda(d, dic1, True)
            if miscl is None: raise Exception
            dic1.setdefault("misclassifications", miscl)
            return dic1
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # performs logistic regression after scaling x between [0, 1] using gradient descent
    @staticmethod
    def _gdslogreg(d: data, p: matx, a: float, m: int, pr: float, ret=False) -> dict:
        try:
            sc = _Calculate._scale0to1x(d.getax(), True)
            if sc is None: raise Exception
            d1 = data(sc["values"], d.data[1], False, True).data1()
            p = _Calculate._scale0to1logreg(sc["constant"], sc["factor"], p, True)
            c = 0
            err = float("inf")
            while c < m:
                pn = _Calculate._logregp(d1, p, a, True)
                if pn is None: raise Exception
                err = math.sqrt(sum([((i[1]-p.mele(0, i[0], False, True))/i[1])**2 for i in enumerate(pn.matx[0])])/p.rowlen)
                if err < pr: break
                p.matx = pn
                for i in range(pn.rowlen):
                    if pn.mele(0, i, False, True) == float("nan") or pn.mele(0, i, False, True) == float("inf") or pn.mele(0, i, False, True) == float("-inf"):
                        print("parameter", i, "is ", pn.mele(0, i, False, True))
                        return {"parameters": p.matxl()[0]}
                c += 1
            p = _Calculate._scaleorignlogreg(sc["constant"], sc["factor"], p, True)
            if p is None: raise Exception
            miscl = _Calculate._misclasslogreg(d.data, p, True)
            if miscl is None: raise Exception
            return {"parameters": p.matxl()[0], "iterations": c, "misclassifications": miscl}
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class _Predict:
    # returns predicted value of y for linear regression
    @staticmethod
    def _linreg(p: matx, x: matx, ret=False) -> float:
        try:
            if p.rowlen != x.rowlen+1: raise Exception(str(x.rowlen)+" != "+str(p.rowlen-1))
            y = matutils.mmult(p, matutils.tpose(matutils.maddone(x, True), True), True).mele(0, 0, False, True)
            if y is None: raise Exception
            return y
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns True for y=1 and False for y=0
    @staticmethod
    def _logreg(p: matx, x: matx, ret=False) -> bool:
        try:
            if p.rowlen != x.rowlen+1: raise Exception(str(x.rowlen)+" != "+str(p.rowlen-1))
            h = 1/(1+pow(math.e, -1*matutils.mmult(p, matutils.tpose(matutils.maddone(x, True), True), True).mele(0, 0, False, True)))
            if h is None: raise Exception
            if h < 0.5: return False
            else: return True
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    # returns True for y=1 and False for y=0
    @staticmethod
    def _gda(d: dict, x: matx, ret=False) -> bool:
        try:
            if d["n"] != x.rowlen: raise Exception(str(d["n"])+" != "+str(x.rowlen))
            dif =  [matutils.msub(x, matx(tuple(i), False, True), True) for i in d["mean"]]
            if dif is None: raise Exception
            cov = matx(tuple([tuple(i) for i in d["cov"]]), False, True)
            if cov is None: raise Exception
            dn = pow(2*math.pi, d["n"]/2)*pow(matutils.dnant(cov, True), 1/2)
            if dn is None: raise Exception
            h = [pow(math.e, (matutils.mmult(matutils.mmult(i, matutils.invse(cov, True), True), matutils.tpose(i, True), True).mele(0, 0, False, True))/-2)/dn for i in dif]
            if h is None: raise Exception
            if h[0] > h[1]: return False
            else: return True
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class LinReg:
    @staticmethod
    def grades(d: data, p: list, a: float, m=100, pr=0.01, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(p, True, True)
            if p is None: raise Exception
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception 
            if p.rowlen != d.xvars+1: raise Exception("number of parameters: "+str(p.rowlen)+" != "+str(d.xvars+1))
            return _Regression._gdlinreg(d, p, a, m, pr, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def matrix(d: data, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            return _Regression._matlinreg(d, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def gradessv(d: data, p: list, a: float, m=100, pr=0.01, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(p, True, True)
            if p is None: raise Exception
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception 
            if p.rowlen != d.xvars+1: raise Exception("number of parameters: "+str(p.rowlen)+" != "+str(d.xvars+1))
            return _Regression._gdslinreg(d, p, a, m, pr, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class WeiLinReg:
    @staticmethod
    def grades(d: data, p: list, a: float, x: list, t=float("inf"), m=100, pr=0.01, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(p, True, True)
            if p is None: raise Exception
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception
            if p.rowlen != d.xvars+1: raise Exception("number of parameters: "+str(p.rowlen)+" != "+str(d.xvars+1))
            x = Comp._flist(x)
            if x is None: raise Exception
            x = matx(tuple(x), False, True)
            if x.rowlen != d.xvars: raise Exception(str(x.rowlen)+" != "+str(d.xvars))
            t = Comp._tfloat(t)
            if t is None: raise Exception
            return _Regression._gdwlinreg(d, p, a, x, t, m, pr, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def matrix(d: data, x: list, t=float('inf'), ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            x = Comp._flist(x)
            if x is None: raise Exception
            x = matx(tuple(x), False, True)
            if x.rowlen != d.xvars: raise Exception(str(x.rowlen)+" != "+str(d.xvars))
            t = Comp._tfloat(t)
            if t is None: raise Exception
            return _Regression._matwlinreg(d, x, t, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def gradessv(d: data, p: list, a: float, x: list, t=float("inf"), m=100, pr=0.01, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(p, True, True)
            if p is None: raise Exception
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception
            if p.rowlen != d.xvars+1: raise Exception("number of parameters: "+str(p.rowlen)+" != "+str(d.xvars+1))
            x = Comp._flist(x)
            if x is None: raise Exception
            x = matx(tuple(x), False, True)
            if x.rowlen != d.xvars: raise Exception(str(x.rowlen)+" != "+str(d.xvars))
            t = Comp._tfloat(t)
            if t is None: raise Exception
            return _Regression._gdswlinreg(d, p, a, x, t, m, pr, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class LogReg:
    @staticmethod
    def grades(d: data, p: list, a: float, m=100, pr=0.01, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(p, True, True)
            if p is None: raise Exception
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception
            if p.rowlen != d.xvars+1: raise Exception("number of parameters: "+str(p.rowlen)+" != "+str(d.xvars+1))
            return _Classification._gdlogreg(d, p, a, m, pr, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def gradessv(d: data, p: list, a: float, m=100, pr=0.01, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(p, True, True)
            if p is None: raise Exception
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception
            if p.rowlen != d.xvars+1: raise Exception("number of parameters: "+str(p.rowlen)+" != "+str(d.xvars+1))
            return _Classification._gdslogreg(d, p, a, m, pr, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @classmethod
    def gradesgc(self, d: dict, p: dict, a: float, m=100, pr=0.01, ret=False) -> dict:
        try:
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            if Compa._matchkeys(d, p) is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception
            if Comp._lenlist([i["parameters"] for i in p.values()]) is None: raise Exception
            if Compd._tdata(list(d.values())) is None: raise Exception
            par = dict()
            for i in p.items():
                x = Comp._flist(i[1]["parameters"])
                if x is None: raise Exception
                par[i[0]] = x
            dic = dict()
            for i in d.items():
                dic[i[0]] = self.grades(i[1], par[i[0]], a, m, pr, True)
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @classmethod
    def gradessvgc(self, d: dict, p: dict, a: float, m=100, pr=0.01, ret=False) -> dict:
        try:
            a = Compa._tfloatp(a)
            if a is None: raise Exception
            if Compa._matchkeys(d, p) is None: raise Exception
            pr = Compa._tfloatp(pr)
            if pr is None: raise Exception
            m = Comp._tintn(m)
            if m is None: raise Exception
            if Comp._lenlist([i["parameters"] for i in p.values()]) is None: raise Exception
            if Compd._tdata(list(d.values())) is None: raise Exception
            par = dict()
            for i in p.items():
                x = Comp._flist(i[1]["parameters"])
                if x is None: raise Exception
                par[i[0]] = x
            dic = dict()
            for i in d.items():
                dic[i[0]] = self.gradessv(i[1], par[i[0]], a, m, pr, True)
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class GDA:
    @staticmethod
    def gda(d: data, ret=False) -> dict:
        try:
            if Compd._tdata(d) is None: raise Exception
            return _Classification._gda(d, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @classmethod
    def gdagc(self, d: dict, ret=False) -> dict:
        try:
            dic = dict()
            for i in d.items(): dic[i[0]] = self.gda(i[1], True)
            return dic
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

class Predict:
    @staticmethod
    def ylinreg(d: data, p: list, ret=False) -> matx:
        try:
            if Compd._tdata(d) is None: raise Exception
            p = Comp._flist(p)
            if p is None: raise Exception
            p = matx(tuple(p), False, True)
            if p is None: raise Exception
            if p.rowlen != d.xvars+1: raise Exception(str(p.rowlen)+" != "+str(d.xvars+1))
            return matx(tuple([tuple(i) for i in _Calculate._ypredy(d.data, p)]), False, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def linreg(p: list, x: list, ret=False) -> float:
        try:
            p = Comp._flist(p)
            if p is None: raise Exception
            x = Comp._flist(x)
            if x is None: raise Exception
            p = matx(tuple(p), False, True)
            if p is None: raise Exception
            x = matx(tuple(x), False, True)
            if x.rowlen+1 != p.rowlen: raise Exception(str(p.rowlen)+" != "+str(x.rowlen+1))
            return _Predict._linreg(p, x, True)
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def logreg(p: list, x: list, ret=False) -> int:
        try:
            p = Comp._flist(p)
            if p is None: raise Exception
            x = Comp._flist(x)
            if x is None: raise Exception
            p = matx(tuple(p), False, True)
            if p is None: raise Exception
            x = matx(tuple(x), False, True)
            if x is None: raise Exception
            if x.rowlen+1 != p.rowlen: raise Exception(str(p.rowlen)+" != "+str(x.rowlen+1))
            y = _Predict._logreg(p, x, True)
            if y == True: return 1
            else: return 0
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @staticmethod
    def gda(d: dict, x: list, ret=False) -> int:
        try:
            if Compa._tdict(d) is None: raise Exception
            x = Comp._flist(x)
            if x is None: raise Exception
            x = matx(tuple(x), False, True)
            if x is None: raise Exception
            if d["n"] != x.rowlen: raise Exception(str(x.rowlen)+" != "+str(d["n"]))
            y = _Predict._gda(d, x, True)
            if y == True: return 1
            else: return 0
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @classmethod
    def logreggc(self, d: dict, x: list, ret=False) -> int:
        try:
            if Compa._tdict(d) is None: raise Exception
            x = Comp._flist(x)
            if x is None: raise Exception
            c = dict()
            for i in d.items():
                cl = self.logreg(i[1]["parameters"], x, True)
                if cl is None: raise Exception
                if cl == 1: c[i[0][1]] = c.setdefault(i[0][1], 0) + 1
                else: c[i[0][0]] = c.setdefault(i[0][0], 0) + 1
            mx = 0
            mc = 0
            for i in c.items():
                if i[1] > mx:
                    mx = i[1]
                    mc = i[0]
            return mc
        except Exception as e:
            print(e)
            Terminate.retrn(ret)
    @classmethod
    def gdagc(self, d: dict, x: list, ret=False) -> int:
        try:
            if Compa._tdict(d) is None: raise Exception
            x = Comp._flist(x)
            if x is None: raise Exception
            c = dict()
            for i in d.items():
                cl = self.gda(i[1], x, True)
                if cl is None: raise Exception
                if cl == 1: c[i[0][1]] = c.setdefault(i[0][1], 0) + 1
                else: c[i[0][0]] = c.setdefault(i[0][0], 0) + 1
            mx = 0
            mc = 0
            for i in c.items():
                if i[1] > mx:
                    mx = i[1]
                    mc = i[0]
            return mc
        except Exception as e:
            print(e)
            Terminate.retrn(ret)

#b = LinReg.matrix(data([[1,2,3],[2,4,6],[3,6,9], [10,12,12], [15,12,10]], [[6],[12],[18],[25],[26]]))
#print(b)
#b = LinReg.gradessv(data([[1,2,3],[2,4,6],[3,6,9], [10,12,12], [15,12,10]], [[6],[12],[18],[25],[26]]), [0,1,1,1], 100)
#print(b)
#a = 0.00196
#b = LinReg.grades(data([[1,2,3],[2,4,6],[3,6,9], [10,12,12], [15,12,10]], [[6],[12],[18],[25],[26]]), [0.5,0.5,0.5,0.5], 0.0196, 1000, 0.01, True)
#print(b)
#c = WeiLinReg.matrix(data([[1,2,3],[2,4,6],[3,6,9], [10,12,12], [15,12,10]], [[6],[12],[18],[25],[26]]), [2,6,4])
#print(c)
#c = WeiLinReg.gradessv(data([[1,2,3],[2,4,6],[3,6,9], [10,12,12], [15,12,10]], [[6],[12],[18],[25],[26]]), [1,1,1,1], 0.01, [2,4,6])
#print(c)
#d = LogReg.grades(data([[10,10,10],[5,7,9],[4,2,7],[5,9,1],[20,20,20],[21,25,22],[14,18,12],[12,15,11]], [[0],[0],[0],[0],[1],[1],[1],[1]]), [-10,1,1,1], 0.01, 1000)
#print(d)
#a = GDA.gda(data([[10,10,10],[5,7,9],[4,2,7],[5,9,1],[20,20,20],[21,25,22],[14,18,12],[12,15,11]], [[0],[0],[0],[0],[1],[1],[1],[1]]))
#print(a)