import json
from data import data, Compd
from matrix import matx, matutils, Comp
from algorithms import Compa
from exec import Terminate

class _Output:
    # save the regression output
    @classmethod
    def _save(self, l: str, d: dict, k: str) -> None:
        dic = {}
        with open(l, 'r') as f:
            dic = json.load(f)
        dic[k] = self._chktuple(d)
        with open(l, 'w') as f:
            json.dump(dic, f)
    @classmethod
    def _chktuple(self, d: dict) -> dict:
        dic = dict()
        for i in d.keys():
            if type(d[i]) == dict:
                if type(i) != tuple: dic.update({i: self._chktuple(d[i])})
                else: dic.update({str(i): self._chktuple(d[i])})
            else:
                if type(i) != tuple: dic.update({i: d[i]})
                else: dic.update({str(i): d[i]})
        return dic
class _getData:
    # transform json data into data object for regression
    @staticmethod
    def _regression(l: str) -> data:
        dic = {}
        with open(l, 'r') as f:
            dic = json.load(f)
        x = list()
        y = list()
        for i in dic["points"].values():
            x.append(i[0])
            y.append([i[1]])
        return data(x, y)
    # transform json data into data object for classification
    @classmethod
    def _classification(self, l: str) -> dict:
        dic = {}
        with open(l, 'r') as f:
            dic = json.load(f)
        d = dict()
        for i, j in dic["classes"].items():
            for k, l in dic["classes"].items():
                if k > i:
                    d[(i, k)] = self._clasdata(j, l)
        return d
    @staticmethod
    def _clasdata(x1: list, x2: list) -> data:
        return data(x1+x2, [[0] for i in range(len(x1))]+[[1] for i in range(len(x2))])
    @staticmethod
    def _regdata(y: list, *x: list) -> data:
        lx = list()
        for i in x[0]:
            lx.append(i)
        return data(matutils.tpose(matx(lx)).matx, y)

class Results:
    @staticmethod
    def save(d: dict, l: list, k: str) -> None:
        _Output._save(l, d, k)

class GetData:
    @staticmethod
    def regression(l: str) -> data:
        return _getData._regression(l)
    @staticmethod
    def classification(l: str) -> dict:
        return _getData._classification(l)
    @staticmethod 
    def regdata(y: list, *x: list) -> data:
        return _getData._regdata(y, x)
    @staticmethod
    def clasdata(c0: list, c1: list) -> data:
        return _getData._clasdata(c0, c1)

def parlogreg(d: dict, p: list) -> dict:
    try:
        if Compa._tdict(d) is None: raise Exception
        p = Comp._flist(p)
        if p is None: raise Exception
        if Compd._tdata(list(d.values())) is None: raise Exception
        pd = dict()
        for i in d.keys():
            pd[i] = {"parameters": p}
        return pd
    except Exception as e:
        print(e)
        Terminate.retrn(True)

def parlogregter(d: dict) -> dict:
    try:
        if Compa._tdict(d) is None: raise Exception
        if Compd._tdata(list(d.values())) is None: raise Exception
        pd = dict()
        for i in d.keys():
            print("class: "+str(i)+"\n")
            p = list()
            for i in range(d[i].xvars+1):
                par = input("parameter "+str(i)+"\n")
                try: par = float(par)
                except ValueError: raise Exception(str(par)+" is not float") 
                if par is None: raise Exception
                p.append(par)
            p = Comp._flist(p)
            if p is None: raise Exception
            pd[i] = {"parameters": p}
        return pd
    except Exception as e:
        print(e)
        Terminate.retrn(True)

#d = GetData.clasdata([[0,1,2],[2,1,2],[2,1,5]], [[2,4,5],[5,6,8]])
#d.pdata
#p = parlogregter(d)
#print(p)
#d = GetData.regdata([1,2,3,4], [1,2,3,4], [2,4,6,8], [1,4,9,16], [4,5,9,8])
#d.pdata